% Copyright (C) 2008-2010 - Consortium Scilab - Digiteo - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/

\section{Quadratic equation}

In this section, we analyze the computation of the roots of a quadratic polynomial.
As we shall see, there is a whole \emph{world} from the mathematical formulas to the 
implementation of such computations. In the first part, we briefly report the formulas which allow to 
compute the real roots of a quadratic equation with real coefficients.
We then present the naive algorithm based on these mathematical formulas. 
In the second part, we make some experiments in Scilab and compare our
naive algorithm with the \scifun{roots} Scilab function.
In the third part, we analyze why and how floating point numbers must be 
taken into account when the roots of a quadratic are required.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Theory}

In this section, we present the mathematical formulas which allow to compute the 
real roots of a quadratic polynomial with real coefficients.
We chose to begin by the example of a quadratic equation, because most of 
us exactly know (or \emph{think} we know) how to solve such an equation with a computer.

Assume that $a, b, c \in \RR$ are given coefficients and $a\neq 0$. 
Consider the following quadratic \cite{wikipediaquadratic,wikipedialossofsign,mathworldquadratic} equation:
\begin{eqnarray}
\label{eq-quadratic}
a x^2 + b x + c = 0,
\end{eqnarray}
where $x\in\RR$ is the unknown.

Let us define by $\Delta=b^2-4ac$ the discriminant of the quadratic equation.
We consider the mathematical solution of the quadratic equation, 
depending on the sign of the discriminant $\Delta=b^2 - 4ac$.
\begin{itemize}
\item If $\Delta> 0$, there are two real roots: 
% Keep two equations for the root selection explanation
\begin{eqnarray}
x_- &=& \frac{-b- \sqrt{\Delta}}{2a}, \label{real:x-} \\
x_+ &=& \frac{-b+ \sqrt{\Delta}}{2a}. \label{real:x+}
\end{eqnarray}
\item If $\Delta=0$, there is one double root:
\begin{eqnarray}
\label{realdouble:x-+}
x_\pm &=& -\frac{b}{2a}.
\end{eqnarray}
\item If $\Delta< 0$, there are two complex roots:
\begin{eqnarray}
\label{complex:x-+}
x_\pm &=&\frac{-b}{2a} \pm i \frac{\sqrt{-\Delta}}{2a}.
\end{eqnarray}
\end{itemize}

We now consider a simplified algorithm where we only compute the real roots of the 
quadratic, assuming that $\Delta>0$.
This naive algorithm is presented in figure \ref{naive-quadratic}.

\begin{algorithm}[htbp]
\SetKwInOut{Input}{input}\SetKwInOut{Output}{output}
\Input{$a,b,c$}
\Output{$x_-$, $x_+$}
$\Delta:= b^2-4ac$\;
$s:= \sqrt{\Delta}$\;
$x_-:= (-b-s)/(2a)$\;
$x_+:= (-b+s)/(2a)$\;
\caption{Naive algorithm to compute the real roots of a quadratic equation. - We assume that $\Delta> 0$.}
\label{naive-quadratic}
\end{algorithm}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Experiments}

In this section, we compare our naive algorithm with the \scifun{roots} function.
We begin by defining a function which naively implements the mathematical formulas.
Then we use our naive function on two particular examples. 
In the first example, we focus on massive cancellation and in the second example, we 
focus on overflow problems.

The following Scilab function \scifun{myroots} is a straightforward implementation
of the previous formulas. It takes as input the coefficients of the quadratic, stored in the 
vector variable \scivar{p}, and returns the two roots in the vector \scivar{r}.
\lstset{language=scilabscript}
\begin{lstlisting}
function r=myroots(p)
  c=coeff(p,0);
  b=coeff(p,1);
  a=coeff(p,2);
  r(1)=(-b+sqrt(b^2-4*a*c))/(2*a);
  r(2)=(-b-sqrt(b^2-4*a*c))/(2*a);
endfunction
\end{lstlisting}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsubsection{Massive cancellation}
\label{section-exp-quadraticrounding}

\index{cancellation}
\index{massive cancellation}
We analyze the rounding errors which are 
appearing when the discriminant of the quadratic equation 
is such that $b^2\gg 4ac$.
We consider the following quadratic equation 
\begin{eqnarray}
\label{sinn-eq-roundingerror}
\epsilon x^2 + (1/\epsilon)x - \epsilon = 0
\end{eqnarray}
with $\epsilon>0$. 
The discriminant of this equation is $\Delta = 1/\epsilon^2+4\epsilon^2$.
The two real solutions of the quadratic equation are
\begin{eqnarray}
\label{sinn-eq-roundingerror-roots}
x_- = \frac{-1/\epsilon- \sqrt{1/\epsilon^2+4\epsilon^2}}{2\epsilon}, \qquad
x_+ = \frac{-1/\epsilon+ \sqrt{1/\epsilon^2+4\epsilon^2}}{2\epsilon}.
\end{eqnarray}

We are mainly interested in the case where the magnitude of $\epsilon$ is very 
small. 
The roots are approximated by 
\begin{eqnarray}
\label{sinn-eq-roundingerror-roots-approx}
x_- \approx  -1/\epsilon^2, \qquad
x_+ \approx  \epsilon^2,
\end{eqnarray}
when $\epsilon$ is close to zero.
We now consider the limit of the two roots when $\epsilon \rightarrow 0$. We have 
\begin{eqnarray}
\lim_{\epsilon\rightarrow 0} x_- = -\infty, \qquad
\lim_{\epsilon\rightarrow 0} x_+ = 0.
\end{eqnarray}

\index{\scifun{roots}}
In the following Scilab script, we compare the roots computed by the \scifun{roots}
function and the roots computed by our naive function. 
Only the positive root $x_+ \approx \epsilon^2$ is considered in this test. 
Indeed, the $x_-$ root is so that $x_- \rightarrow -\infty$ in both implementations.
We consider the special case $\epsilon=0.0001=10^{-4}$. 
We begin by creating a polynomial with the \scifun{poly} function, which is given the coefficients of 
the polynomial. 
The variable \scivar{e1} contains the expected value of the positive root $x_+=\epsilon^2$. 
Then we compute the roots \scivar{r1} and \scivar{r2} with the two functions 
\scifun{roots} and \scifun{myroots}. 
We finally compute the relative errors \scivar{error1} and \scivar{error2}. 
\lstset{language=scilabscript}
\begin{lstlisting}
p=poly([-0.0001 10000.0 0.0001],"x","coeff");
e1 = 1e-8;
roots1 = myroots(p);
r1 = roots1(1);
roots2 = roots(p);
r2 = roots2(1);
error1 = abs(r1-e1)/e1;
error2 = abs(r2-e1)/e1;
printf("Expected : %e\n", e1);
printf("Naive method : %e (error=%e)\n", r1,error1);
printf("Scilab method : %e (error=%e)\n", r2, error2);
\end{lstlisting}

The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
Expected : 1.000000e-008
Naive method : 9.094947e-009 (error=9.050530e-002)
Scilab method : 1.000000e-008 (error=1.654361e-016)
\end{lstlisting}

We see that the naive method produces a root which has no significant digit 
and a relative error which is 14 orders of magnitude greater than the relative 
error of the Scilab root.

This behavior is explained by the fact that the expression for the 
positive root $x_+$ given by the equality \ref{real:x+} is numerically evaluated 
as following. We first consider how the discriminant $\Delta = 1/\epsilon^2+4\epsilon^2$ 
is computed. The term $1/\epsilon^2$ is equal to 100000000 and the term $4\epsilon^2$ 
is equal to 0.00000004. Therefore, the sum of these two terms is equal to 100000000.000000045.
Hence, the square root of the discriminant is 
\begin{eqnarray}
\sqrt{1/\epsilon^2+4\epsilon^2} = 10000.000000000001818989.
\end{eqnarray}
As we see, the first digits are correct, but the last digits 
are subject to rounding errors. When the expression $-1/\epsilon+ \sqrt{1/\epsilon^2+4\epsilon^2}$
is evaluated, the following computations are performed~:
\begin{eqnarray}
-1/\epsilon+ \sqrt{1/\epsilon^2+4\epsilon^2} &=& -10000.0 + 10000.000000000001818989 \\
  &=& 0.0000000000018189894035
\end{eqnarray}
We see that the result is mainly driven by the cancellation of significant digits.

We may think that the result is extreme, but it 
is not. For example, consider the case where we reduce further the value of $\epsilon$ down to 
$\epsilon=10^{-11}$, we get the following output :
\begin{lstlisting}
Expected : 1.000000e-022
Naive method : 0.000000e+000 (error=1.000000e+000)
Scilab method : 1.000000e-022 (error=1.175494e-016)
\end{lstlisting}

The relative error is this time 16 orders of magnitude 
greater than the relative error of the Scilab root.
There is no significant decimal digit in the result. 
In fact, the naive implementation computes a false root $x_+$ even for 
a value of epsilon equal to $\epsilon=10^{-3}$, where the relative 
error is 7 orders of magnitude greater than the relative error produced by the 
\scifun{roots} function.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsubsection{Overflow}
\label{section-exp-quadraticoverflow}

\index{overflow}
In this section, we analyse the overflow which appears  
when the discriminant of the quadratic equation 
is such that $b^2- 4ac$ is not representable as a double.
We consider the following quadratic equation 
\begin{eqnarray}
\label{sinn-eq-overflowerror}
x^2 + (1/\epsilon)x + 1 = 0
\end{eqnarray}
with $\epsilon>0$. We especially consider the case $\epsilon\rightarrow 0$. 
The discriminant of this equation is $\Delta=1/\epsilon^2 -4$. Assume that the discriminant is positive.
Therefore, the roots of the quadratic equation are 
\begin{eqnarray}
x_- = \frac{-1/\epsilon- \sqrt{1/\epsilon^2-4}}{2}, \qquad
x_+ = \frac{-1/\epsilon+ \sqrt{1/\epsilon^2-4}}{2}.
\end{eqnarray}
These roots are approximated by 
\begin{eqnarray}
\label{sinn-eq-rootsoverflowapprox}
x_- \approx  -1/\epsilon, \qquad
x_+ \approx  -\epsilon,
\end{eqnarray}
when $\epsilon$ is close to zero.
We now consider the limit of the two roots when $\epsilon \rightarrow 0$. We have 
\begin{eqnarray}
\lim_{\epsilon\rightarrow 0} x_- = -\infty, \qquad
\lim_{\epsilon\rightarrow 0} x_+ = 0^-.
\end{eqnarray}
To create a difficult case, we search $\epsilon$ so that 
$1/\epsilon^2 > 10^{308}$, because we know that $10^{308}$
is the maximum representable double precision floating 
point number. Therefore, we expect that something should go wrong 
in the computation of the expression $\sqrt{1/\epsilon^2-4}$. 
We choose $\epsilon=10^{-155}$.

In the following script, we compare the roots computed by the \scifun{roots}
function and our naive implementation.
\lstset{language=scilabscript}
\begin{lstlisting}
e=1.e-155
a = 1;
b = 1/e;
c = 1;
p=poly([c b a],"x","coeff");
expected = [-e;-1/e];
roots1 = myroots(p);
roots2 = roots(p);
error1 = abs(roots1-expected)/norm(expected);
error2 = abs(roots2-expected)/norm(expected);
printf("Expected : %e %e\n", expected(1),expected(2));
printf("Naive method : %e %e (error=%e %e)\n", ...
  roots1(1),roots1(2), error1(1),error1(2));
printf("Scilab method : %e %e (error=%e %e)\n", ...
  roots2(1),roots2(2), error2(1),error2(2));
\end{lstlisting}

The previous script produces the following output.
\begin{lstlisting}
Expected : -1.000000e-155 -1.000000e+155
Naive method : Inf Inf (error=Nan Nan)
Scilab method : -1.000000e-155 -1.000000e+155 
            (error=0.000000e+000 0.000000e+000)
\end{lstlisting}

In this case, the discriminant $\Delta = b^2-4ac$ has been evaluated as $1/\epsilon^2-4$,
which is approximately equal to $10^{310}$. This number cannot 
be represented in a double precision floating point number. It therefore produces the 
IEEE Infinite number, which is displayed by Scilab as \scivar{Inf}.
The Infinite number is associated with an algebra and functions can perfectly 
take this number as input. Therefore, when the square root function 
must compute $\sqrt{\Delta}$, it produces again \scivar{Inf}. This number is 
then propagated into the final roots.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Explanations}

In this section, we suggest robust methods to compute the roots of a 
quadratic equation. 

\index{Jenkins, M. A.}
\index{Traub, J. F.}
The methods presented in this section are extracted from the 
\emph{quad} routine of the \emph{RPOLY} algorithm by
Jenkins and Traub \cite{JenkinsTraub1970,Jenkins1975}. This algorithm is used by Scilab in the 
\scifun{roots} function, where a special case is used when the 
degree of the equation is equal to 2, i.e. a quadratic equation.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsubsection{Properties of the roots}

In this section, we present elementary results, which will be 
used in the derivation of robust floating point formulas of the roots 
of the quadratic equation. 

Let us assume that the quadratic equation \ref{eq-quadratic}, with 
real coefficients $a,b,c\in\RR$ and $a>0$ has a positive 
discriminant $\Delta=b^2-4ac$. Therefore, the two real roots of 
the quadratic equation are given by the equations \ref{real:x-} and \ref{real:x+}.
We can prove that the sum and the product of the roots satisfy the equations 
\begin{eqnarray}
\label{eq-rootsprops}
x_- + x_+ =\frac{-b}{a},\qquad
x_- x_+ =\frac{c}{a}.
\end{eqnarray}
Therefore, the roots are the solution of the normalized 
quadratic equation 
\begin{eqnarray}
\label{eq-rootsprops2}
x^2 - (x_- + x_+) x  + x_- x_+ &=&0.
\end{eqnarray}

Another transformation leads to an alternative form of the roots. 
Indeed, the original quadratic equation can be written as a quadratic 
equation of the unknown $1/x$. Consider the quadratic equation \ref{eq-quadratic}
and divide it by $1/x^2$, assuming that $x\neq 0$. This leads to the equation 
\begin{eqnarray}
\label{eq-quadraticinverse}
c(1/x)^2 + b (1/x)  + a &=&0,
\end{eqnarray}
where we assume that $x\neq 0$.
The two real roots of the quadratic equation \ref{eq-quadraticinverse} are 
\begin{eqnarray}
% Keep two equations for the root selection explanation
x_- &=& \frac{2c}{-b+ \sqrt{b^2-4ac}}, \label{real:x-inverse}\\
x_+ &=& \frac{2c}{-b- \sqrt{b^2-4ac}} \label{real:x+inverse}.
\end{eqnarray}
The expressions \ref{real:x-inverse} and \ref{real:x+inverse} can 
also be derived directly from the equations \ref{real:x-} and \ref{real:x+}.
For that purpose, it suffices to multiply their numerator and denominator 
by $-b+ \sqrt{b^2-4ac}$.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsubsection{Floating-Point implementation : overview}

The numerical experiments presented in sections \ref{section-exp-quadraticrounding} and
\ref{section-exp-quadraticoverflow} suggest that the floating point implementation
must deal with two different problems:
\begin{itemize}
\item massive cancellation when $b^2\gg 4ac$ because of the cancellation of the 
terms $-b$ and $\pm\sqrt{b^2-4ac}$ which may have opposite signs,
\item overflow in the computation of the square root of the 
discriminant $\sqrt{\pm(b^2-4ac)}$ when $b^2-4ac$ is not representable as 
a floating point number.
\end{itemize}

The cancellation problem occurs only when the discriminant is positive, i.e. only
when there are two real roots. Indeed, the cancellation will not appear when $\Delta<0$,
since the complex roots do not use the sum $-b\pm\sqrt{b^2-4ac}$.
When $\Delta=0$, the double real root does not cause any trouble.
Therefore, we must take into account for the cancellation problem only in the 
equations \ref{real:x-} and \ref{real:x+}.

On the other hand, the overflow problem occurs whatever the sign of the discriminant
but does not occur when $\Delta=0$. Therefore, we must take into account 
for this problem in the equations \ref{real:x-}, \ref{real:x+} and \ref{complex:x-+}.
In section \ref{section-quadratic-fixcancellation}, we focus on the cancellation error while 
the overflow problem is addressed in section \ref{section-quadratic-fixoverflow}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsubsection{Floating-Point implementation : fixing massive cancellation}
\label{section-quadratic-fixcancellation}
In this section, we present the computation of the roots of a 
quadratic equation with protection against massive cancellation. 

When the discriminant $\Delta$ is positive, the massive cancellation problem can be split in two cases:
\begin{itemize}
\item if $b<0$, then $-b-\sqrt{b^2-4ac}$ may suffer of massive cancellation
because $-b$ is positive and $-\sqrt{b^2-4ac}$ is negative,
\item if $b>0$, then $-b+\sqrt{b^2-4ac}$ may suffer of massive cancellation because 
$-b$ is negative and $\sqrt{b^2-4ac}$ is positive.
\end{itemize}
Therefore, 
\begin{itemize}
\item if $b>0$, we should use the expression $-b-\sqrt{b^2-4ac}$,
\item if $b<0$, we should use the expression $-b+\sqrt{b^2-4ac}$.
\end{itemize}
The solution consists in a combination of the following expressions of the 
roots given by, on one hand the equations \ref{real:x-} and \ref{real:x+},
and, on the other hand the equations \ref{real:x-inverse} and \ref{real:x+inverse}.
We pick the formula so that the sign of $b$ is the 
same as the sign of the square root.
The following choice allow to solve the massive cancellation problem:
\begin{itemize}
\item if $b<0$, then compute $x_-$ from \ref{real:x-inverse}, else 
(if $b>0$), compute $x_-$ from \ref{real:x-},
\item if $b<0$, then compute $x_+$ from \ref{real:x+}, else 
(if $b>0$), compute $x_+$ from \ref{real:x+inverse}.
\end{itemize}

We can also consider the modified Fagnano formulas
\begin{eqnarray}
x_1 &=& -\frac{2c}{b+sgn(b)\sqrt{b^2-4ac}}, \\
x_2 &=& -\frac{b+sgn(b)\sqrt{b^2-4ac}}{2a}, 
\end{eqnarray}
where the sign function is defined by 
\begin{eqnarray}
sgn(b)=\left\{\begin{array}{l}
1, \textrm{ if } b\geq 0,\\
-1, \textrm{ if } b< 0.
\end{array}\right.
\end{eqnarray}
The roots $x_{1,2}$ correspond to the roots $x_{+,-}$. Indeed, on one hand, 
if $b<0$, $x_1=x_-$ and if $b>0$, $x_1=x_+$. On the other hand, if $b<0$, $x_2=x_+$ and
if $b>0$, $x_2=x_-$.

Moreover, we notice that the division by two (and the multiplication
by 2) is exact with floating point numbers so these operations
cannot be a source of problem. But it is 
interesting to use $b/2$, which involves only one division, instead
of the three multiplications $2*c$, $2*a$ and $4*a*c$.
This leads to the following expressions of the real roots 
\begin{eqnarray}
x_1 &=& -\frac{c}{(b/2)+sgn(b)\sqrt{(b/2)^2-ac}}, \\
x_2 &=& -\frac{(b/2)+sgn(b)\sqrt{(b/2)^2-ac}}{a}.
\end{eqnarray}
Therefore, the two real roots can be computed by the following sequence of 
computations:
\begin{eqnarray}
b'&:=&b/2, \qquad \Delta' := b'^2-ac,\\
h&:=& -\left(b'+sgn(b)\sqrt{\Delta'}\right)\\
x_1 &:=& \frac{c}{h}, \qquad x_2 := \frac{h}{a}. 
\end{eqnarray}

In the case where the discriminant $\Delta' := b'^2-ac$ is negative, the 
two complex roots are
\begin{eqnarray}
x_1 &=& -\frac{b'}{a} - i \frac{\sqrt{ac-b'^2}}{a}, \qquad 
x_2 = -\frac{b'}{a} + i \frac{\sqrt{ac-b'^2}}{a}. 
\end{eqnarray}

A more robust algorithm, based on the previous analysis is presented in figure \ref{robust-quadratic}.
By comparing \ref{naive-quadratic} and \ref{robust-quadratic}, we can see that 
the algorithms are different in many points.

\begin{algorithm}[htbp]
\SetKwInOut{Input}{input}\SetKwInOut{Output}{output}
\Input{$a,b,c$}
\Output{$x_-^R$, $x_-^I$, $x_+^R$, $x_+^I$}
\uIf {$a=0$} {
        \eIf {$b=0$} {
             $x_-^R:= 0$ , $x_-^I:= 0$ \;
             $x_+^R:= 0$ , $x_+^I:= 0$ \;
        } {
             $x_-^R:= -c/b$ , $x_-^I:= 0$ \;
             $x_+^R:= 0$ , $x_+^I:= 0$ \;
        }
}
\Else {
         $b':= b/2$ \;
         $\Delta:= b'^2 - ac$ \;
        \uIf {$\Delta<0$} {
                 $s:= \sqrt{-\Delta}$ \;
                 $x_-^R:= -b'/a$ , $x_-^I:= -s/a$ \;
                 $x_+^R:= x_-^R$ , $x_+^I:= -x_1^I$ \;
        }
        \uElseIf {$\Delta=0$} {
                 $x_-:= -b'/a$ , $x_-^I:= 0$ \;
                 $x_+:= x_2$ , $x_+^I:= 0$ \;
        }
        \Else {
                 $s:= \sqrt{\Delta}$ \;
                \uIf {$b>0$}{
                     $g:=1$ \;
                }
                \Else {
                     $g:=-1$ \;
                }
                 $h:=-(b'+g*s)$ \;
                 $x_-^R:= c/h$ , $x_-^I:= 0$ \;
                 $x_+^R:= h/a$ , $x_+^I:= 0$ \;
        }
}
\caption{A more robust algorithm to compute the roots of a quadratic equation. This algorithm 
takes as input arguments the real coefficients $a,b,c$ and returns the real and imaginary parts 
of the two roots, i.e. returns $x_-^R$, $x_-^I$, $x_+^R$, $x_+^I$.}
\label{robust-quadratic}
\end{algorithm}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsubsection{Floating-Point implementation : fixing overflow problems}
\label{section-quadratic-fixoverflow}

The remaining problem is to compute the square root of the 
discriminant $\sqrt{\pm(b'^2-ac)}$ without creating 
unnecessary overflows. In order to simplify the discussion, we 
focus on the computation of $\sqrt{b'^2-ac}$.

Obviously, the problem occur for large values of $b'$. 
Notice that a (very) small improvement has already been done. Indeed, we have the 
inequality $|b'|=|b|/2<|b|$
so that overflows are twice less likely to occur. The current upper bound 
for $|b'|$ is $10^{154}$, which is associated with 
$b^{'2}\leq 10^{308}$, the maximum double value before overflow.
The goal is therefore to increase the possible range of values of $b'$ without 
generating unnecessary overflows.

Consider the situation when $b'$ is large in magnitude with respect to $a$ and $c$. 
In that case, notice that we first square $b'$ to get $b^{'2}$
and then compute the square root $\sqrt{b^{'2} - ac}$.
Hence, we can factor the expression by $b^{'2}$ and move this 
term outside the square root, which makes the term $|b'|$ appear.
This method allows to compute the expression $\sqrt{b^{'2} - ac}$,
without squaring $b'$ when it is not necessary.

In the general case, we use the fact that the term $b'^2-ac$ can be 
evaluated with the two following equivalent formulas:
\begin{eqnarray}
b'^2-ac &=& b'^2\left[1-(a/b')(c/b')\right], \label{eq-discroverflow1}\\
b'^2-ac &=& c\left[b'(b'/c) - a\right].\label{eq-discroverflow2}
\end{eqnarray}
The goal is then to compute the square root $s = \sqrt{b'^2-ac}$.
\begin{itemize}
\item If $|b'|>|c|>0$, then the equation \ref{eq-discroverflow1} involves the expression $1-(a/b')(c/b')$.
The term $1-(a/b')(c/b')$ is so that no overflow is possible since $|c/b'| < 1$ (the overflow problem occurs
only when $b$ is large in magnitude with respect to both $a$ and $c$).
In this case, we use the expression
\begin{eqnarray}
e &=& 1-(a/b')(c/b'),
\end{eqnarray}
and compute
\begin{eqnarray}
\label{quadratic-overflow-trick1}
s &=& \pm|b'|\sqrt{|e|}.
\end{eqnarray}
In the previous equation, we use the sign + when $e$ is positive
and the sign - when $e$ is negative.

\item If $|c|>|b'|>0$, then the equation \ref{eq-discroverflow2} involves the expression $b'(b'/c) - a$.
The term $b'(b'/c) - a$ should limit the possible overflows since $|b'/c| < 1$. This implies that 
$\left|b'(b'/c)\right|<|b'|$. (There is 
still a possibility of overflow, for example in the case where $b'(b'/c)$
is near, but under, the overflow limit and $a$ is large.)
Therefore, we use the expression
\begin{eqnarray}
e &=& b'(b'/c) - a,
\end{eqnarray}
and compute 
\begin{eqnarray}
\label{quadratic-overflow-trick2}
s &=& \pm\sqrt{|c|} \sqrt{|e|}.
\end{eqnarray}
In the previous equation, we use the sign + when $e$ is positive
and the sign - when $e$ is negative.
\end{itemize}
In both equations \ref{quadratic-overflow-trick1} and \ref{quadratic-overflow-trick2}, 
the parenthesis must be strictly used. This property is ensured by the IEEE standard 
and by the Scilab language. 
This normalization method are similar to the one used by Smith in the 
algorithm for the division of complex numbers \cite{Smith1962} and 
which will be reviewed in the next section.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsubsection{Conditioning of the problem}

The conditioning of the problem may be evaluated with the 
computation of the partial derivatives of the roots of the 
equations with respect to the coefficients.
These partial derivatives measure the sensitivity of the 
roots of the equation with respect to small errors which might 
by associated with the coefficients of the quadratic equations.
In the following, we assume that $a\neq 0$.

First, assume that the discriminant is positive,
i.e. assume that $\Delta>0$. Therefore, the roots given by the equations 
\ref{real:x-} and \ref{real:x+} can be directly differentiated. 
This leads to 
\begin{eqnarray}
\begin{array}{ll}
\frac{\partial x_-}{\partial a} = \frac{c}{a\sqrt{\Delta}} + \frac{b+\sqrt{\Delta}}{2a^2}, \qquad 
&\frac{\partial x_+}{\partial a} = -\frac{c}{a\sqrt{\Delta}} + \frac{b-\sqrt{\Delta}}{2a^2}\\
\frac{\partial x_-}{\partial b} = \frac{-1-b/\sqrt{\Delta}}{2a}, \qquad
&\frac{\partial x_+}{\partial b} = \frac{-1+b/\sqrt{\Delta}}{2a}\\
\frac{\partial x_-}{\partial c} = \frac{1}{\sqrt{\Delta}}, \qquad
&\frac{\partial x_+}{\partial c} = -\frac{1}{\sqrt{\Delta}}.
\end{array}
\end{eqnarray}

Second, if the discriminant is zero, the partial derivatives of the 
double real root are the following :
\begin{eqnarray}
\frac{\partial x_\pm}{\partial a} = \frac{b}{2a^2}, \qquad 
\frac{\partial x_\pm}{\partial b} = \frac{-1}{2a}, \qquad 
\frac{\partial x_\pm}{\partial c} = 0.
\end{eqnarray}

In both cases, we see that when the coefficient $a$ converges toward zero,
some of the partial derivatives are converging toward $\pm\infty$.
For example, if $\Delta>0$, then $\lim_{a\rightarrow 0} \frac{\partial x_-}{\partial a} \rightarrow \pm\infty$.
We also see that behavior when the discriminant converges toward zero.
This implies that, in the case where $a$ or $\Delta$ are small, a small change in the 
coefficient is associated to a large change in the roots. This is the definition 
of an ill-conditioned problem. 

We can relate this ill-conditioning problem to the eigenvalue problem of a 
square matrix $A$. Indeed, it is a well-known result that, when $A$ is non-normal, it may happen that 
small changes in $A$ can induce large changes in the eigenvalues\cite{GolubVanLoad1996},
chapter 7, "The Unsymmetric Eigenvalue Problem".
The eigenvalue problem and the roots of a quadratic equation are related 
by the fact that the eigenvalues are the roots of the characteristic 
polynomial. Moreover, a very general method to find the roots of a 
polynomial is to find the eigenvalues of its companion matrix.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{References}

\index{Forsythe, George}
The 1966 technical report by G. Forsythe \cite{Forsythe1966} 
presents the floating point system and the possible large error 
in using mathematical algorithms blindly. An accurate way of solving 
a quadratic is outlined. A few general remarks are made about 
computational mathematics. 

\index{Goldberg, David}
The 1991 paper by Goldberg \cite{WhatEveryComputerScientist} is a general presentation of the floating
point system and its consequences. It begins with background on floating point 
representation and rounding errors, continues with a discussion
of the IEEE floating point standard and concludes with examples of how
computer system builders can better support floating point. The section
1.4, "Cancellation" specifically consider the computation of the roots
of a quadratic equation.

We can also read the numerical experiments performed by Nievergelt in \cite{Nievergelt2003}.

The Numerical Recipes \cite{NumericalRecipes}, chapter 5, section 5.6,
"Quadratic and Cubic Equations" present the elementary theory 
for a floating point implementation of the quadratic and cubic equations.

\index{Kahan, William}
Other references include William Kahan \cite{Kahan2004}.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{footnotesize}
\subsection{Exercises}

\begin{exercise}[Roots of the normalized quadratic equation]
\label{exe-rootsnormalizedquadratic}
We consider the normalized quadratic equation:
\begin{eqnarray}
\label{eq-normalizedquadratic}
x^2 + a x + b = 0,
\end{eqnarray}
where $a,b\in\RR$ are given coefficients and $x\in\RR$ is the 
unknown.
Prove that the roots of the normalized quadratic equation \ref{eq-normalizedquadratic} are the following.
Let us define $\delta = \frac{a^2}{4} - b$.
\begin{itemize}
\item If $\delta> 0$, there are two real roots, 
\begin{eqnarray}
x_\pm &=& -\frac{a}{2}\pm \sqrt{\frac{a^2}{4} - b}
\end{eqnarray}
\item If $\delta= 0$, there is one double real root, 
\begin{eqnarray}
x &=& -\frac{a}{2}.
\end{eqnarray}
\item If $\delta< 0$, there are two complex roots, 
\begin{eqnarray}
x_\pm &=& -\frac{a}{2} \pm i \sqrt{b - \frac{a^2}{4}}
\end{eqnarray}
\end{itemize}
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Roots of the quadratic equation]
\label{exe-rootsquadratic}
We consider the quadratic equation \ref{eq-quadratic} 
where $a,b,c\in\RR$ are given coefficients and $x\in\RR$ is the 
unknown. We assume that $a\neq 0$.
Prove that the roots of the quadratic equation \ref{eq-quadratic} are 
given by the equations \ref{real:x-}, \ref{real:x+}, \ref{realdouble:x-+} and \ref{complex:x-+}.
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Properties of the roots]
\label{exe-rootsprop}
Prove the equations \ref{eq-rootsprops}.
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Inverted roots]
\label{exe-rootsinverse}
Based on the equations \ref{real:x-} and \ref{real:x+}, prove directly the 
equations \ref{real:x-inverse} and \ref{real:x+inverse}, i.e. prove that 
\begin{eqnarray}
x_-&=&\frac{-b- \sqrt{\Delta}}{2a} = \frac{2c}{-b+ \sqrt{b^2-4ac}}, \\
x_+ &=&\frac{-b+ \sqrt{\Delta}}{2a} = \frac{2c}{-b- \sqrt{b^2-4ac}}.
\end{eqnarray}
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Expansion of $\sqrt{1+x}$ near $x=0$]
\label{sinn-exe-taylorexpansionsqrt}
Prove that, when $x$ is in the neighborhood of zero, we have 
\begin{eqnarray}
\label{eq-expansion-sqrt}
\sqrt{1+x} = 1 + \frac{1}{2} x  - \frac{1}{8} x^2 + \frac{1}{16} x^3 + O(x^4).
\end{eqnarray}
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Roots of a quadratic equation \#1]
\label{sinn-exe-roundingerror-roots}
Prove the approximations \ref{sinn-eq-roundingerror-roots-approx}.
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Roots of a quadratic equation \#2]
\label{sinn-exe-rootsoverflowapprox}
Prove the approximations \ref{sinn-eq-rootsoverflowapprox}.
\end{exercise}

\end{footnotesize}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Answers to exercises}

\begin{footnotesize}

\begin{answer}{\ref{exe-rootsnormalizedquadratic}}{Roots of the normalized quadratic equation}
We use the following change of variable 
\begin{eqnarray}
\label{eq-nqchangevar}
x = t + \lambda
\end{eqnarray}
where $t\in\RR$ is the unknown and $\lambda \in \RR$ is a parameter.
This parameter will be tuned so that the linear term in the quadratic equation is zero.
We plug the change of variable \ref{eq-nqchangevar} into the equation 
\ref{eq-normalizedquadratic} and get
\begin{eqnarray}
x^2 + a x + b 
&=& ( t + \lambda )^2 + a(t + \lambda) + b \\
&=& t^2 + 2t\lambda +\lambda^2 + at +a\lambda + b \\
&=&0.
\end{eqnarray}
We can organize the previous expression by decreasing powers of the unknown $t$.
Hence, the unknown $t\in\RR$ must be a solution of the equation
\begin{eqnarray}
\label{eq-nqpolyt}
t^2 + (a + 2 \lambda) t + (\lambda^2 + a \lambda + b) = 0
\end{eqnarray}
The linear term is zero if 
\begin{eqnarray}
a + 2 \lambda = 0.
\end{eqnarray}
Therefore, we choose to define $\lambda$ by the equation 
\begin{eqnarray}
\lambda = -\frac{a}{2}.
\end{eqnarray}
Hence, the change of variable is 
\begin{eqnarray}
\label{eq-nqchangevar2}
x = t -\frac{a}{2}.
\end{eqnarray}
The constant term in the equation \ref{eq-nqpolyt} can be simplified into
\begin{eqnarray}
\lambda^2 + a \lambda + b 
&=& \left(-\frac{a}{2}\right)^2 + a\left(-\frac{a}{2}\right) + b\\
&=& \frac{a^2}{4}-\frac{a^2}{2}+b\\
&=&-\frac{a^2}{4} + b.
\end{eqnarray}
The equation \ref{eq-nqpolyt} is now simplified and the 
unknown $t$ must be a root of the equation
\begin{eqnarray}
t^2 + (b-\frac{a^2}{4}) = 0.
\end{eqnarray}
The previous equation can be expressed as
\begin{eqnarray}
\label{eq-nqpolytsimple}
t^2 = \delta 
\end{eqnarray}
where $\delta$ is defined by 
\begin{eqnarray}
\delta = \frac{a^2}{4} - b.
\end{eqnarray}

The roots of the quadratic equation \ref{eq-nqpolytsimple} can be found depending 
on the sign of $\delta$.
\begin{itemize}

\item If $\delta> 0$, there are two real roots, 
\begin{eqnarray}
t_\pm = \pm \sqrt{\delta}.
\end{eqnarray}
The roots $x_\pm$ can then be computed by using the change of 
variable \ref{eq-nqchangevar2}. This leads to 
\begin{eqnarray}
x_\pm 
&=& t_\pm -\frac{a}{2}\\
&=& -\frac{a}{2} \pm \sqrt{\delta}\\
&=&-\frac{a}{2}\pm \sqrt{\frac{a^2}{4} - b}
\end{eqnarray}

\item If $\delta= 0$, there is one double root 
\begin{eqnarray}
t_\pm = 0.
\end{eqnarray}
The change of variable \ref{eq-nqchangevar2} leads to 
\begin{eqnarray}
x_\pm &=&  -\frac{a}{2}.
\end{eqnarray}

\item If $\delta< 0$, there are two complex roots, 
\begin{eqnarray}
t_\pm = \pm i \sqrt{-\delta}
\end{eqnarray}
and the change of variable \ref{eq-nqchangevar2} leads to 
\begin{eqnarray}
x_\pm &=& -\frac{a}{2} \pm i \sqrt{-\delta}\\
&=& -\frac{a}{2} \pm i \sqrt{b - \frac{a^2}{4}}.
\end{eqnarray}
\end{itemize}
We have analyzed the roots depending on the sign of the discriminant 
$\delta$ and the proof is complete.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-rootsquadratic}}{Roots of the quadratic equation}
We use the result of the exercise \ref{exe-rootsnormalizedquadratic}.
We consider the quadratic equation \ref{eq-quadratic} 
where $a,b,c\in\RR$ are given coefficients and $x\in\RR$ is the 
unknown. We assume that $a\neq 0$. Therefore, we 
can divide the equation \ref{eq-quadratic} by $a$ and get
\begin{eqnarray}
\label{eq-quadraticnormalized2}
x^2 + a' x + b' = 0,
\end{eqnarray}
where $a'=\frac{b}{a}$ and $b'=\frac{c}{a}$.
The discriminant is
\begin{eqnarray}
\delta 
&=& \frac{a'^2}{4} - b' \\
&=& \frac{(b/a)^2}{4} - (c/a) \\
&=& \frac{b^2}{4a^2} - \frac{c}{a}\\
&=& \frac{b^2 - 4ac}{4a^2}.
\end{eqnarray}
We define $\Delta$ by the equation $\Delta=b^2 - 4ac$. Therefore,
we have $\delta=\frac{\Delta}{4a^2}$. Since $4a^2>0$, the signs of 
$\delta$ and $\Delta$ are the same and $\delta=0$ if and only 
if $\Delta=0$.

We plug the previous definitions of $a'$ and $b'$ into the roots of the normalized equation 
given by exercise \ref{exe-rootsnormalizedquadratic} and get the 
following result.
\begin{itemize}
\item If $\Delta> 0$, there are two real roots: 
\begin{eqnarray}
\label{eq-realrootssimple1}
x_\pm 
&=& -\frac{a'}{2} \pm \sqrt{\delta} \\
&=& -\frac{b}{2a} \pm \frac{\sqrt{\Delta}}{2a} \\
&=& \frac{-b \pm \sqrt{\Delta}}{2a}
\end{eqnarray}
which proves the equations \ref{real:x-} and \ref{real:x+}.
\item If $\Delta=0$, there is one double root:
\begin{eqnarray}
x_\pm 
&=& -\frac{a'}{2} \\
&=& -\frac{b}{2a}.
\end{eqnarray}
We have proved the equation \ref{realdouble:x-+}.
\item If $\Delta< 0$, there are two complex roots:
\begin{eqnarray}
x_\pm 
&=& -\frac{a'}{2} \pm i \sqrt{-\delta}\\
&=& -\frac{b}{2a} \pm i \frac{\sqrt{-\Delta}}{2a}
\end{eqnarray}
which proves the equation \ref{complex:x-+}.
\end{itemize}
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-rootsprop}}{Properties of the roots}
Let us prove the equations \ref{eq-rootsprops} in the three cases 
$\Delta>0$, $\Delta=0$ and $\Delta<0$.
First, assume that $\Delta>0$. Then, by the equations \ref{real:x-} and \ref{real:x+}, 
the sum of the roots is 
\begin{eqnarray}
x_- + x_+ 
&=& \frac{-b-\sqrt{\Delta}}{2a} + \frac{-b+\sqrt{\Delta}}{2a} \\
&=& \frac{-2b}{2a} \\
&=& \frac{-b}{a}.
\end{eqnarray}
The product of the roots is 
\begin{eqnarray}
x_- . x_+ 
&=& \left(\frac{-b-\sqrt{\Delta}}{2a} \right)\left( \frac{-b+\sqrt{\Delta}}{2a}\right) \\
&=& \frac{b^2-\Delta}{4a^2} \\
&=& \frac{b^2-(b^2-4ac)}{4a^2} \\
&=& \frac{4ac}{4a^2} \\
&=& \frac{c}{a}.
\end{eqnarray}
Second, assume that $\Delta=0$. By the equation \ref{realdouble:x-+},
the sum of the roots is 
\begin{eqnarray}
x_- + x_+ 
&=& \frac{-b}{2a} + \frac{-b}{2a} \\
&=& \frac{-b}{a}.
\end{eqnarray}
The product of the roots is 
\begin{eqnarray}
x_- . x_+ 
&=& \left(\frac{-b}{2a} \right)\left( \frac{-b}{2a}\right) \\
&=& \frac{b^2}{4a^2}.
\label{eq-rootsprop3}
\end{eqnarray}
But the equality $\Delta=0$ implies $b^2=4ac$.
We plug this last equality in the equation \ref{eq-rootsprop3},
and we find 
\begin{eqnarray}
x_- . x_+ 
&=& \frac{4ac}{4a^2} \\
&=& \frac{c}{a}.
\end{eqnarray}
Finally, assume that $\Delta<0$.
Then, by the equations \ref{complex:x-+}, 
the sum of the roots is 
\begin{eqnarray}
x_- + x_+ 
&=& \frac{-b}{2a} - i \frac{\sqrt{-\Delta}}{2a} + \frac{-b}{2a} + i \frac{\sqrt{-\Delta}}{2a} \\
&=& \frac{-2b}{2a} \\
&=& \frac{-b}{a}.
\end{eqnarray}
The product of the roots is 
\begin{eqnarray}
x_- . x_+ 
&=& \left(\frac{-b}{2a} - i \frac{\sqrt{-\Delta}}{2a} \right)\left( \frac{-b}{2a} + i \frac{\sqrt{-\Delta}}{2a}\right) \\
&=& \left(\frac{-b}{2a}\right)^2 + \left(\frac{\sqrt{-\Delta}}{2a}\right)^2 \\
&=& \frac{b^2}{4a^2} + \frac{-\Delta}{4a^2} \\
&=& \frac{b^2}{4a^2} + \frac{4ac-b^2}{4a^2} \\
&=& \frac{4ac}{4a^2} \\
&=& \frac{c}{a}.
\end{eqnarray}
The three cases $\Delta>0$, $\Delta=0$ and $\Delta<0$ have been considered
so that the proof is complete.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-rootsinverse}}{Inverted roots}
Based on the equations \ref{real:x-} and \ref{real:x+}, let us prove directly the 
equations \ref{real:x-inverse} and \ref{real:x+inverse}, i.e. let us prove that 
\begin{eqnarray}
x_-&=&\frac{-b- \sqrt{\Delta}}{2a} = \frac{2c}{-b+ \sqrt{b^2-4ac}}, \\
x_+ &=&\frac{-b+ \sqrt{\Delta}}{2a} = \frac{2c}{-b- \sqrt{b^2-4ac}}.
\end{eqnarray}
First, we multiply the numerator and the denominator of $x_-$ by $-b+ \sqrt{\Delta}$.
This leads to 
\begin{eqnarray}
x_-&=&\frac{-b- \sqrt{\Delta}}{2a} \cdot \frac{-b+ \sqrt{\Delta}}{-b+ \sqrt{\Delta}} \\
&=&\frac{(-b)^2- (\sqrt{\Delta})^2}{2a(-b+ \sqrt{\Delta})}\\
&=&\frac{b^2- \Delta}{2a(-b+ \sqrt{\Delta})}\\
&=&\frac{b^2- (b^2-4ac)}{2a(-b+ \sqrt{\Delta})}\\
&=&\frac{4ac}{2a(-b+ \sqrt{\Delta})}\\
&=&\frac{2c}{-b+ \sqrt{\Delta}}.
\end{eqnarray}
Second, we multiply the numerator and the denominator of $x_+$ by $-b- \sqrt{\Delta}$.
This leads to 
\begin{eqnarray}
x_+&=&\frac{-b+ \sqrt{\Delta}}{2a} \cdot \frac{-b- \sqrt{\Delta}}{-b- \sqrt{\Delta}} \\
&=&\frac{(-b)^2- (\sqrt{\Delta})^2}{2a(-b- \sqrt{\Delta})}\\
&=&\frac{b^2- \Delta}{2a(-b- \sqrt{\Delta})}\\
&=&\frac{b^2- (b^2-4ac)}{2a(-b- \sqrt{\Delta})}\\
&=&\frac{4ac}{2a(-b- \sqrt{\Delta})}\\
&=&\frac{2c}{-b- \sqrt{\Delta}}.
\end{eqnarray}
This proves the equalities \ref{real:x-inverse} and \ref{real:x+inverse}.
\end{answer}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{sinn-exe-taylorexpansionsqrt}}{Expansion of $\sqrt{1+x}$ near $x=0$}
Assume that $f$ is a continuously differentiable function. 
By Taylor's theorem, we have
\begin{eqnarray}
\label{eq-Taylor-1D}
f(x+h) = f(x) + h f^\prime(x) + \frac{1}{2} h^2 f^{\prime\prime}(x)
+ \frac{1}{6} h^3 f^{\prime\prime\prime}(x) + O(h^4).
\end{eqnarray}
We use the Taylor's expansion \ref{eq-Taylor-1D} with $f(x)=\sqrt{x}$
in the neighborhood of $x=1$. 
The derivatives of the function $f$ are 
\begin{eqnarray}
f^\prime(x) = \frac{1}{2} x^{-\frac{1}{2}}, \qquad 
f^{\prime\prime}(x) = -\frac{1}{4} x^{-\frac{3}{2}},\qquad  
f^{\prime\prime\prime}(x) = \frac{3}{8} x^{-\frac{5}{2}},
\end{eqnarray}
so that 
\begin{eqnarray}
f(1) = 1, \qquad 
f^\prime(1) = \frac{1}{2}, \qquad 
f^{\prime\prime}(1) = -\frac{1}{4}, \qquad
f^{\prime\prime\prime}(1) &=& \frac{3}{8}.
\end{eqnarray}
The Taylor expansion \ref{eq-Taylor-1D} therefore implies 
\begin{eqnarray}
\sqrt{1+h} &=& 1 +  h \cdot \frac{1}{2} + \frac{1}{2} h^2 \cdot \left(-\frac{1}{4}\right)
+ \frac{1}{6} h^3 \cdot \frac{3}{8} + O(h^4),\\
&=& 1 + \frac{1}{2} h - \frac{1}{8} h^2 
+ \frac{1}{16} h^3 + O(h^4).
\end{eqnarray}
The previous equality proves the equality \ref{eq-expansion-sqrt}
and concludes the proof.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{sinn-exe-roundingerror-roots}}{Roots of a quadratic equation \#1}
Let us prove the approximations \ref{sinn-eq-roundingerror-roots-approx}.
The two real solutions of the quadratic equation \ref{sinn-eq-roundingerror} are
\begin{eqnarray}
x_- = \frac{-1/\epsilon- \sqrt{1/\epsilon^2+4\epsilon^2}}{2\epsilon}, \qquad
x_+ = \frac{-1/\epsilon+ \sqrt{1/\epsilon^2+4\epsilon^2}}{2\epsilon}.
\end{eqnarray}
Let us prove that 
\begin{eqnarray}
\label{sinn-eq-roundingerror-roots-approx2}
x_- \approx  -1/\epsilon^2, \qquad
x_+ \approx  \epsilon^2.
\end{eqnarray}
Based on the Taylor expansion \ref{eq-expansion-sqrt}, we can simplify the expression
$\sqrt{1/\epsilon^2+4\epsilon^2}$. Indeed, we have 
\begin{eqnarray}
\sqrt{1/\epsilon^2+4\epsilon^2} &=& \sqrt{\frac{1 + 4\epsilon^4}{\epsilon^2}}\\
 &=& \frac{\sqrt{1 + 4\epsilon^4}}{\epsilon}
\end{eqnarray}
By the equation \ref{eq-expansion-sqrt}, we have 
\begin{eqnarray}
\sqrt{1 + 4\epsilon^4} 
&= & 1 + \frac{1}{2} (4\epsilon^4)  - \frac{1}{8} (4\epsilon^4)^2 + O(\epsilon^{12})\\
&= & 1 + 2\epsilon^4  - 2\epsilon^8 + O(\epsilon^{12}).
\end{eqnarray}
We divide the previous equation by $\epsilon$ and get 
\begin{eqnarray}
\sqrt{1/\epsilon^2+4\epsilon^2}
&= & \frac{1}{\epsilon} + 2\epsilon^3  - 2\epsilon^7 + O(\epsilon^{11}).
\end{eqnarray}
This implies 
\begin{eqnarray}
-1/\epsilon - \sqrt{1/\epsilon^2+4\epsilon^2}
&= & -\frac{1}{\epsilon} -\frac{1}{\epsilon} - 2\epsilon^3  + 2\epsilon^7+ O(\epsilon^{11}),\\
&= & -\frac{2}{\epsilon} - 2\epsilon^3  + O(\epsilon^7),\\
-1/\epsilon + \sqrt{1/\epsilon^2+4\epsilon^2}
&= & -\frac{1}{\epsilon} +\frac{1}{\epsilon} +2\epsilon^3  - 2\epsilon^7 + O(\epsilon^{11})\\
&= & 2\epsilon^3  - 2\epsilon^7 + O(\epsilon^{11}).
\end{eqnarray}
We notice that the term $\frac{1}{\epsilon}$ has been \emph{canceled}
in the previous calculation. This cancelation generates the rounding error which is 
the topic of the associated numerical experiment. 
We divide the previous equations by $2\epsilon$ and finally get 
\begin{eqnarray}
x_- &=& -\frac{1}{\epsilon^2} - \epsilon^2  + O(\epsilon^6),\\
x_+ &=& \epsilon^2  - \epsilon^6 + O(\epsilon^{10}).
\end{eqnarray}
The two previous equations directly imply the approximations \ref{sinn-eq-roundingerror-roots-approx2}, 
when we consider that $\epsilon$ is close to zero.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{sinn-exe-rootsoverflowapprox}}{Roots of a quadratic equation \#2}
Let us prove the approximations \ref{sinn-eq-roundingerror-roots-approx}.
The two real solutions of the quadratic equation \ref{sinn-eq-overflowerror} are
\begin{eqnarray}
x_- = \frac{-1/\epsilon- \sqrt{1/\epsilon^2-4}}{2}, \qquad
x_+ = \frac{-1/\epsilon+ \sqrt{1/\epsilon^2-4}}{2}.
\end{eqnarray}
Let us prove that 
\begin{eqnarray}
\label{sinn-eq-rootsoverflowapprox2}
x_- \approx  -1/\epsilon, \qquad
x_+ \approx  -\epsilon.
\end{eqnarray}
Based on the Taylor expansion \ref{eq-expansion-sqrt}, we can simplify the expression
$\sqrt{1/\epsilon^2-4}$. Indeed, we have 
\begin{eqnarray}
\sqrt{1/\epsilon^2-4} &=& \sqrt{\frac{1-4\epsilon^2}{\epsilon^2}}\\
&=& \frac{\sqrt{1-4\epsilon^2}}{\epsilon}.
\label{sinn-eq-rootsoverflowapprox3}
\end{eqnarray}
Therefore, 
\begin{eqnarray}
\sqrt{1-4\epsilon^2} 
&= & 1 + \frac{1}{2} (-4\epsilon^2)  - \frac{1}{8} (-4\epsilon^2)^2 + O(\epsilon^6)\\
&= & 1 - 2\epsilon^2  - \frac{1}{2}\epsilon^4 + O(\epsilon^6).
\end{eqnarray}
By equation \ref{sinn-eq-rootsoverflowapprox3}, the previous equation 
can be divided by $\epsilon$, which leads to 
\begin{eqnarray}
\sqrt{1/\epsilon^2-4}
&= & \frac{1}{\epsilon} - 2\epsilon  - \frac{1}{2}\epsilon^3 + O(\epsilon^5).
\end{eqnarray}
We now compute the expressions which appear in the calculation of the 
roots $x_-$ and $x_+$. The previous equation leads to 
\begin{eqnarray}
-\frac{1}{\epsilon} - \sqrt{1/\epsilon^2-4}
&= & -\frac{1}{\epsilon} -\frac{1}{\epsilon} + 2\epsilon + \frac{1}{2} \epsilon^3 + O(\epsilon^5), \\
&= & -\frac{2}{\epsilon}  + 2\epsilon + O(\epsilon^3), \\
-\frac{1}{\epsilon} + \sqrt{1/\epsilon^2-4}
&= & -\frac{1}{\epsilon} +\frac{1}{\epsilon} - 2\epsilon - \frac{1}{2} \epsilon^3 + O(\epsilon^5), \\
&= & - 2\epsilon - \frac{1}{2} \epsilon^3 + O(\epsilon^5).
\end{eqnarray}
We divide the two previous equations by $2$ and finally get:
\begin{eqnarray}
x_- &=& -\frac{1}{\epsilon}  + \epsilon + O(\epsilon^3), \\
x_+ &=& - \epsilon - \frac{1}{4} \epsilon^3 + O(\epsilon^5).
\end{eqnarray}
The previous equations imply the approximations \ref{sinn-eq-rootsoverflowapprox2}, 
when we consider that $\epsilon$ is close to zero.
\end{answer}

\end{footnotesize}


